const app = getApp();

function generateToken(wxCode, bizType, idCard = '', name = '') {
  const { baseUrl } = app.globalData;
  return new Promise((resolve) => {
    wx.request({
      url: `${baseUrl}/api/v1/demo/GetToken`,
      method: 'POST',
      data: {
        Code: wxCode,
        IdCard: idCard,
        Name: name,
        BizType: bizType,
      },
      success: (res) => {
        if (!res.data || !res.data.EidToken) {
          wx.showModal({
            title: '提示',
            content: res.data.Msg || '获取token失败，请重新尝试',
            showCancel: false,
          });
          resolve('');
        } else {
          resolve(res.data.EidToken);
        }
      },
      fail: (err) => {
        console.log('获取token失败', err);
        wx.showModal({
          title: '提示',
          content: '获取token失败，请重新尝试',
          showCancel: false,
        });
        resolve('');
      },
    });
  });
}

export default generateToken;
