/* eslint-disable */

/**
 * idnumber check
 */
const IDNumberValid = function (code) {
  let city = {
    11: '北京',
    12: '天津',
    13: '河北',
    14: '山西',
    15: '内蒙古',
    21: '辽宁',
    22: '吉林',
    23: '黑龙江 ',
    31: '上海',
    32: '江苏',
    33: '浙江',
    34: '安徽',
    35: '福建',
    36: '江西',
    37: '山东',
    41: '河南',
    42: '湖北 ',
    43: '湖南',
    44: '广东',
    45: '广西',
    46: '海南',
    50: '重庆',
    51: '四川',
    52: '贵州',
    53: '云南',
    54: '西藏 ',
    61: '陕西',
    62: '甘肃',
    63: '青海',
    64: '宁夏',
    65: '新疆',
    71: '台湾',
    81: '香港',
    82: '澳门',
    91: '国外',
  };

  if (
    !code ||
    !/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[0-2])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i.test(code)
  ) {
    // console.log("IDNumberValid 1st | ");
    return false;
  } else if (!city[code.substr(0, 2)]) {
    // console.log("IDNumberValid 2ed | ");
    return false;
  } else {
    // console.log("IDNumberValid 3th | ");
    //18位身份证需要验证最后一位校验位
    if (code.length === 18) {
      code = code.split('');
      //∑(ai×Wi)(mod 11)
      //加权因子
      const factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
      //校验位
      const parity = [1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2];
      let sum = 0;
      let ai = 0;
      let wi = 0;
      for (let i = 0; i < 17; i++) {
        ai = code[i];
        wi = factor[i];
        sum += ai * wi;
      }
      let last = parity[sum % 11];
      if (code[17] === 'x' || code[17] === 'X') {
        return last === code[17].toUpperCase() ? true : false;
      } else if (last !== parseInt(code[17])) {
        return false;
      }
    }
  }
  return true;
};

const validate = function (data, dataType) {
  switch (dataType) {
    case 'signature':
      // Length 76, last "==""   "xxxxxx...xxxxx=="
      return /^\S{74}={2}$/.test(data);
      break;
    case 'appid':
      // Can't be number and 4 number
      return typeof data === 'string' && /^\d{4}$/.test(data);
      break;
    case 'uid':
      // Not null
      return data;
      break;
    case 'sms_phone':
      // return /^(13[0-9]|14[5-9]|15[012356789]|16[6]|17[0135678]|18[0-9]|19[8-9])\d{8}$/.test(data)
      return /^1\d{10}$/.test(data);
      break;
    case 'sms_verifyCode':
      return /^\d{4}$/.test(data);
    case 'idcard':
      return IDNumberValid(data);
      break;
    case 'idname':
      // return /^[\u4e00-\u9fa5]{1,15}[·•]?[\u4e00-\u9fa5]{1,15}$/.test(data)
      return data && !data.match(/[A-z0-9]/g);
      break;
    case 'idaddress':
      // Not null
      return data ? true : false;
      break;
    case 'end_path':
      return /^\//.test(data);
      break;
    case 'token':
      return /^[a-zA-Z0-9-]{36}$/.test(data);
      break;
  }
};

export default validate;